package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.compat.GemCuttingCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting.GemCuttingMenu;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.ItemLike;

public class GemCuttingRecipe {
  protected final ItemStack out;
  
  protected final ItemStack gem;
  
  protected final ItemStack dust;
  
  protected final ItemStack[] materials;
  
  public GemCuttingRecipe(Gem gem, LootRarity rarity) {
    this.out = GemRegistry.createGemStack(gem, rarity.next());
    this.gem = GemRegistry.createGemStack(gem, rarity);
    this.dust = new ItemStack((ItemLike)Adventure.Items.GEM_DUST.get(), GemCuttingMenu.getDustCost(rarity));
    LootRarity min = (LootRarity)RarityRegistry.getMinRarity().get();
    if (rarity == min) {
      this.materials = new ItemStack[2];
      this.materials[0] = new ItemStack((ItemLike)rarity.getMaterial(), 3);
      this.materials[1] = new ItemStack((ItemLike)rarity.next().getMaterial(), 1);
    } else if ("ancient".equals(RarityRegistry.INSTANCE.getKey((CodecProvider)rarity.next()).m_135815_())) {
      this.materials = new ItemStack[2];
      this.materials[0] = new ItemStack((ItemLike)rarity.prev().getMaterial(), 9);
      this.materials[1] = new ItemStack((ItemLike)rarity.getMaterial(), 3);
    } else {
      this.materials = new ItemStack[3];
      this.materials[0] = new ItemStack((ItemLike)rarity.prev().getMaterial(), 9);
      this.materials[1] = new ItemStack((ItemLike)rarity.getMaterial(), 3);
      this.materials[2] = new ItemStack((ItemLike)rarity.next().getMaterial(), 1);
    } 
  }
}
